/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QSTATESETTINGS_H
#define QSTATESETTINGS_H

#include <QWidget>
#include <QLabel>
#include <QResizeEvent>
#include <QSpinBox>
#include <QSettings>
#include <QDBusConnection>
#include <QDBusInterface>

#include "config.h"
/**
	@author Rico Rommel <rico@bierrommel.de>
*/
class QStateSettings : public QWidget
{
	Q_OBJECT

public:
    QStateSettings(QString text, QWidget * parent, QDBusInterface *interface);

    ~QStateSettings();
    void setBrightness(int brightness);
    int brightness();
    void setTimeout(int timeout);
    int timeout();
    void disableBrightness();
    void disableTimeout();
    void saveSettings(QSettings *settings);
    void loadSettings(QSettings *settings);
    QString getName();
    void setBrightnessMinimum( int min );
    void setTimeoutMinimum( int min );

protected:
    QLabel * state;
    QSpinBox *TimeoutBox;
    QSpinBox *BrightnessBox;
    QString name;
    virtual void resizeEvent( QResizeEvent *event);
    QDBusInterface *idleinterface;

protected slots:
    void TimeoutChanged(int timeout);

};

#endif
